routes/web.php
<?php

use App\Http\Controllers\ArticlesCommentsController;
use App\Http\Controllers\ArticlesController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [ArticlesController::class, 'index'])->name('dashboard');

Route::resource('articles', ArticlesController::class);
Route::delete('articles/{article}/destroy', [ArticlesController::class, 'delete'])->name('articles.delete');

Route::resource('articles.comments', ArticlesCommentsController::class)->only(['store', 'destroy']);

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Article.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Article extends Model
{
    use HasFactory;

    protected $fillable = ['title', 'content'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)->orderBy('id', 'desc');
    }
}

app/Http/Controllers/ArticlesController.php
<?php

namespace App\Http\Controllers;

use App\Models\Article;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Routing\Redirector;

class ArticlesController extends Controller
{
    /**
     * ArticlesController constructor.
     */
    public function __construct()
    {
        $this->middleware('auth')->except('index');
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View|Response
     */
    public function index()
    {
        $articles = Article::orderBy('id', 'desc')->paginate(9);
        return view('articles.index', compact('articles'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View|Response
     */
    public function create()
    {
        return view('articles.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @return Application|RedirectResponse|Response|Redirector
     */
    public function store(Request $request)
    {
        $article = new Article();
        $article->title = $request->input('title');
        $article->content = $request->input('content');
        $article->user_id = $request->user()->id;
        $article->save();

        return redirect(route('dashboard'));
    }

    /**
     * Display the specified resource.
     *
     * @param Article $article
     * @return Application|Factory|View|Response
     */
    public function show(Article $article)
    {
        $article->setRelation('comments', $article->comments()->paginate(5));
        return view('articles.show', compact('article'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Article $article
     * @return Application|Factory|View|Response
     * @throws AuthorizationException
     */
    public function edit(Article $article)
    {
        $this->authorize('edit', $article);
        return view('articles.edit', compact('article'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param Request $request
     * @param Article $article
     * @return Application|RedirectResponse|Response|Redirector
     * @throws AuthorizationException
     */
    public function update(Request $request, Article $article)
    {
        $this->authorize('update', $article);
        $article->update($request->all());
        return redirect(route('articles.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Article $article
     * @return JsonResponse
     * @throws AuthorizationException
     */
    public function destroy(Article $article)
    {
        $this->authorize('delete', $article);
        $article->delete();

        return response()->json([
            'status'=> 'ok'
        ], 204);
    }

    /**
     * @param Article $article
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function delete(Article $article)
    {
        $this->authorize('delete', $article);
        $article->delete();
        return redirect()->route('articles.index');
    }
}

resources/views/articles/create.blade.php
@extends('layouts.app')

@section('content')
  <div class="col-12">
    <h1>Create new Article</h1>
  </div>
  <div class="col-12">
    <form method="post" action="{{route('articles.store')}}">
      @csrf
      <div class="form-group">
        <label for="article-title">Title</label>
        <input name="title" type="text" class="form-control"
               id="article-title">
      </div>
      <div class="form-group">
        <label for="exampleInputPassword1">Content</label>
        <textarea
          name="content"
          class="form-control"
          id="exampleInputPassword1"></textarea>
      </div>
      <button type="submit" class="btn btn-primary">Create article</button>
    </form>
  </div>
  <div style="padding-top: 25px" class="col-2">
    <a href="{{route('articles.index')}}" class="btn btn-primary btn-sm
active" role="button"
       aria-pressed="true">Back</a>
  </div>
@endsection

resources/views/articles/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="col">
        <h1>Update {{$article->title}} article</h1>
    </div>
    <div class="col">
        <form method="post" action="{{route('articles.update', ['article' => $article])}}">
            @csrf
            @method('put')
            <div class="form-group">
                <label for="article-title">Title</label>
                <input name="title" type="text" class="form-control"
                       id="article-title" value="{{$article->title}}">
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Content</label>
                <textarea
                    rows="9"
                    name="content"
                    class="form-control"
                    id="exampleInputPassword1">{{$article->content}}</textarea>
            </div>

            @can('update', $article)
                <button type="submit" class="btn btn-primary">Update article</button>
            @endcan
        </form>
    </div>
    <div style="padding-top: 25px" class="col-2">
        <a href="{{route('articles.index')}}" class="btn btn-primary btn-sm
active" role="button"
           aria-pressed="true">Back</a>
    </div>
@endsection

resources/views/articles/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="row">
      <div class="col">
        <h3>
            Articles
            @if (Auth::check())
                <a href="{{route('articles.create')}}" class="btn btn-primary btn-sm
  active" role="button" aria-pressed="true">Create new Article</a>
            @endif
        </h3>
      </div>
    </div>
  <div class="row">
    @csrf
    @foreach($articles as $article)
      <div class="col" style="padding: 35px 0 0 0;" id="delete-article-{{$article->id}}">
        <div class="card" style="width: 18rem;">
          <div class="card-header">
            {{ $article->title }}
            <span class="badge badge-info" style="cursor: pointer"
                  title="Comments count">
{{$article->comments->count()}}
</span>
            @can('delete', $article)
              <span style="cursor: pointer;" data-article-id="{{$article->id}}" class="delete" aria-hidden="true" title="Delete article {{$article->title}}">&times;</span>
            @endcan
          </div>
          <div class="card-body">
            <blockquote class="blockquote mb-0">
              <p class="text-truncate">
                {{ $article->content }}
              </p>
            </blockquote>
            <a href="{{route('articles.show', ['article' =>
$article])}}" class="card-link">Show more ...</a> <br>
            @can('update', $article)
              <a href="{{route('articles.edit', ['article' =>
$article])}}" class="card-link">Edit</a>
            @endcan
          </div>
        </div>
      </div>
    @endforeach
  </div>
  <div class="row p-5">
    <div class="col-12 offset-4">
      {{ $articles->links("pagination::bootstrap-4") }}
    </div>
  </div>
@endsection

resources/views/articles/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="row">
        <div class="col">
            <div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLongTitle">Attention</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body" id="attention-modal-body">

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">Close</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <h3 class="article-title">
                {{$article->title}}
                @can('delete', $article)
                <form style="display: inline-block;" action="{{route('articles.delete', compact('article'))}}" method="post">
                    @csrf
                    @method('delete')
                    <button type="submit" class="btn btn-sm btn-outline-danger">Remove article</button>
                </form> |
                @endcan

                @can('edit', $article)
                    <a class="btn btn-sm btn-outline-primary" href="{{route('articles.edit', compact('article'))}}">Edit article</a>
                @endcan
            </h3>
            <blockquote class="blockquote">
                <p class="mb-2" style="text-align: justify">
                    {{$article->content}}
                </p>
                <footer class="blockquote-footer">
                    Author: {{$article->user->name}}, created in
                    <cite title="Created at article">
                        {{$article->created_at->diffForHumans()}}
                    </cite>
                </footer>
            </blockquote>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <h3>
                Comments
                <button type="button" class="btn btn-sm btn-primary" data-toggle="modal"
                        data-target="#exampleModalScrollable">
                    Add comment
                </button>
            </h3>
        </div>
    </div>
    <div class="modal fade" id="exampleModalScrollable" tabindex="-1" role="dialog"
         aria-labelledby="exampleModalScrollableTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalScrollableTitle">Create new comment</h5>
                    <button type="button" class="close close-create-comment-modal" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="comment-form">
                        <form id="create-comment">
                            @csrf
                            <input type="hidden" id="article_id" value="{{$article->id}}">
                            <div class="form-group">
                                <label for="bodyId">Comment</label>
                                <textarea id="bodyId" name="body" class="form-control" rows="3"
                                          required></textarea>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary close-create-comment-modal" data-dismiss="modal">Close</button>
                    <button type="button" id="create-comment-btn" class="btn btn-primary">Comment</button>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col scrollit">
            @foreach($article->comments as $comment)
                <x-comment-component :comment="$comment"></x-comment-component>
            @endforeach
        </div>
    </div>
@endsection